#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySailingaChievementCFG.h"
std::auto_ptr<M_ActivitySailingaChievementCFG> M_ActivitySailingaChievementCFG::msSingleton(nullptr);

int M_ActivitySailingaChievementCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySailingaChievementCFGData* M_ActivitySailingaChievementCFG::GetData(int Id)
{
	auto it = mMapData.find(Id);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySailingaChievementCFGData>& M_ActivitySailingaChievementCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySailingaChievementCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySailingaChievementCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySailingaChievementCFGData data;
		data.mId = element->IntAttribute("Id");
		data.mType = element->IntAttribute("Type");
		data.mTaskTitle = element->Attribute("TaskTitle");
		data.mTaskDesc = element->Attribute("TaskDesc");
		data.mCompleteType = element->IntAttribute("CompleteType");
		{
			const char* CompleteParam = element->Attribute("CompleteParam");
			std::vector<std::string> vecCompleteParam;
			boost::split(vecCompleteParam, CompleteParam, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecCompleteParam.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecCompleteParam[i].c_str(), &temp))
				{
					data.mCompleteParam.push_back(temp);
				}
			}
		}
		data.mCompleteCount = element->IntAttribute("CompleteCount");
		data.mAchievementItem = element->IntAttribute("AchievementItem");
		data.mAchievementCounts = element->IntAttribute("AchievementCounts");
		data.mAwardItemID = element->IntAttribute("AwardItemID");
		data.mAwardItemCounts = element->IntAttribute("AwardItemCounts");
		data.mGoType = element->IntAttribute("GoType");
		{
			const char* FindRand = element->Attribute("FindRand");
			std::vector<std::string> vecFindRand;
			boost::split(vecFindRand, FindRand, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecFindRand.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecFindRand[i].c_str(), &temp))
				{
					data.mFindRand.push_back(temp);
				}
			}
		}
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySailingaChievementCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaChievementCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySailingaChievementCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySailingaChievementCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySailingaChievementCFGData data;
		LuaCfgHelper::readInt(L, "Id", data.mId);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "TaskTitle", data.mTaskTitle);
		LuaCfgHelper::readString(L, "TaskDesc", data.mTaskDesc);
		LuaCfgHelper::readInt(L, "CompleteType", data.mCompleteType);
		LuaCfgHelper::readVectorInt(L, "CompleteParam", data.mCompleteParam);
		LuaCfgHelper::readInt(L, "CompleteCount", data.mCompleteCount);
		LuaCfgHelper::readInt(L, "AchievementItem", data.mAchievementItem);
		LuaCfgHelper::readInt(L, "AchievementCounts", data.mAchievementCounts);
		LuaCfgHelper::readInt(L, "AwardItemID", data.mAwardItemID);
		LuaCfgHelper::readInt(L, "AwardItemCounts", data.mAwardItemCounts);
		LuaCfgHelper::readInt(L, "GoType", data.mGoType);
		LuaCfgHelper::readVectorInt(L, "FindRand", data.mFindRand);
		if (mMapData.find(data.mId) != mMapData.end())std::cout <<"data refind:" << data.mId << std::endl;
		CCASSERT(mMapData.find(data.mId) == mMapData.end(), "data.mId is exists");
		mMapData.insert(std::make_pair(data.mId, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySailingaChievementCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySailingaChievementCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySailingaChievementCFG* M_ActivitySailingaChievementCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySailingaChievementCFG());
	}
	return msSingleton.get();
}

void M_ActivitySailingaChievementCFG::Release()
{
	msSingleton.reset(nullptr);
}
